/***************************************************************
 * Part     : 328 BASE
 * Author   : 2018/02/04	nauzou
 * Update   : 2019/01/14	nauzou
 *				USART ʐM֌Wǉ
 * Update   : 2019/05/03	nauzou
 *				I/O ֌Wǉ
 * Update   : 2019/05/12	nauzou
 *				Timer ֌Wǉ
 */

#include <ctype.h>
#include "std.h"
#include "pio.h"
#include "timer.h"
#include "usart.h"

/********************************************************************
		[Jϐ
********************************************************************/
const PROGMEM char	hi_str[]      = "Hi";
const PROGMEM char	middle_str[]  = "Middle";
const PROGMEM char	low_str[]     = "Low";
const PROGMEM char	off_str[]     = "Off";

/********************************************************************
		ʊ֐
********************************************************************/
/*---------------------------------------------------------
 * Function :
 *  @C[vB
 */
int
main()
{
	const char	*stat_str;
	
	init_pio();
	init_timer();
	init_usart();
	
	irq_enable( IRQ_ENABLE );
	
	usart_puts_p( PSTR("LED test2(PWM)\n") );
	
    while( 1 ) {
    	/* R}h		*/
		switch( toupper( usart_getc() ) ) {
		  case	'H':	/* H or h : PWM 100% œ_						*/
		  	OCR0A    = 0xff;
		  	stat_str = hi_str;
		  	break;
		  case	'M':	/* M or m : PWM 50% œ_						*/
		  	OCR0A    = 0x80;
		  	stat_str = middle_str;
		  	break;
		  case	'L':	/* L or l : PWM 25% œ_						*/
		  	OCR0A    = 0x40;
		  	stat_str = low_str;
		  	break;
		  case	'0':	/* 0      : 								*/
		  	OCR0A    = 0x00;
		  	stat_str = off_str;
		  	break;
		  default:		/* ̑̕R[h͖iwhile [v̐擪ցj	*/
		  	continue;
		}
		
		/* OCR0A  0 ɂĂ 62.5ns ق On ɂȂĂ܂ OC0A o͐ݒ؂ւ	*/
		if( OCR0A == 0 )
			TCCR0A &= ~(1 << COM0A1);	/* W|[g (o͂Ȃ) 				*/
		else
			TCCR0A |=  (1 << COM0A1);	/* RyA}b` 0ABOTTOM  1 o		*/
		
		/* ݂̌ʐݒ USART őM	*/
		usart_printf_p( PSTR("LED %S\n"),stat_str );
	}
}
